//
function SetDomain() {
    if (location.host.toLowerCase().indexOf('.sflep.com') > 0)
        document.domain = "sflep.com";
}
SetDomain();

//var readonlywords = "._children,._count,.launch_data,.session_time,.total_time,.short_cuts,.sco_information,.course_ information,cci.mode,.statistic";
var readonlywords = "._children,._count,.response_status,.teacher_comment,.user,.class";
function IsReadOnly(str) {
    var words = readonlywords.split(',');
    for (var w in words) {
        if (str.indexOf(words[w]) != -1) {
            return true;
        }
    }

    return false;
}

//lmsʼ
var API_1484_11;

var tempData = '';
var LMS = function (id, info) {
    this.scoid = id;
    // ݿıеõĴѧϰ
    this.studyinfo = info;
    this.networkstate = true;
    this.comState = "Not Initialized";
    this.data = '';
    this.errcode = 0;
    this.adldatachanged = false;
    this.newwordchanged = false;
    //NPWEB-278
    this.ccidatachanged = false;
    //NPWEB-278 end

    this.curUserID = '';
    this.curUserName = '';
    this.curUserAccount = '';
    this.curUserToken = '';

    this.curClassID;
    this.curClassName;

    this.classResponseCount;
    this.classAvgScore;
    this.classAvgTime;

    this.arrInteractionResponseStatus;  //飬潻ѧϰͳϢ

    this.hasGetTeaComment = false;
    this.hasGetLearnerComment = false;
    this.hasGetShareInfo = false;
    this.hasGetShareComment = false;
    this.hasGetShareCommentArray = new Array();
}

LMS.prototype = {
    Initialize: function (parm) {

        if (this.comState == "Running") {
            this.errcode = 103;
            return "false";
        }
        //		if (comState == "Terminated")
        //		{
        //			errcode = 104;
        //			return false;
        //		}
        if (parm != "") {
            this.errcode = 201;
            return "false";
        }

        try {
            this.data = GetStudyInfo(this.scoid);
        }
        catch (err) {
            if (err == "timeout") {
                this.errcode = 6011;
                this.comState = "Not Initialized";
                return "false";
            }
            else
            {
                this.errcode = 102;
                this.comState = "Not Initialized";
                return "false";
            }
        }

        if (this.data == '')
            this.data = defaultData;
        if (typeof (this.data) == "string") {
            try {
                this.data = eval('(' + this.data + ')');
            }
            catch (ex) {
                this.errcode = 102;
                this.comState = "Not Initialized";
                return "false";
            }
        }

        this.errcode = 0;
        this.comState = "Running";
        return "true";
    },
    Terminate: function (parm) {

        try {

            if (this.comState == "Not Initialized") {
                this.errcode = 112;
                return "false";
            }
            if (this.comState == "Terminated") {
                this.errcode = 113;
                return "false";
            }
            if (parm != "") {
                this.errcode = 201;
                return "false";
            }

            this.scoid = '';
            this.errcode = 0;
            this.data = null;
            this.comState = "Terminated";

            return "true";
        }
        catch (ex) {
            this.errcode = 111;
            return "false";
        }
    },
    GetValue: function (parm) {
		this.errcode = 0;
        if (this.comState == "Not Initialized") {
            this.errcode = 122;
            return "";
        }
        if (this.comState == "Terminated") {
            this.errcode = 123;
            return "";
        }
        if (!this.networkstate) {
            this.errcode = 6011;
            return "";
        }
        try {

            switch (parm) {
                case 'cmi.session_time':
                    try {
                        var ret = GetSessionTime(this);
                    }
                    catch (err) {
                        if (err == "timeout") {
                            this.errcode = 6011;
                            return "";
                        }
                    }
                    this.errcode = 0;
                    return ret;
                case 'cci.service.scoid':
                    this.errcode = 0;
                    return this.scoid;
                default:
                    var ret = GetJsonVal(parm, this.data, this);
					if (ret == '')
					{					
						if (parm == 'cci.service.play.offline_media_id'){
							ret = 9999;
							this.errcode = 0;
						}
						else if (parm == 'cci.service.record.language'){
							ret = 'en_us';
							this.errcode = 0;
						}
						else if (parm == 'cci.service.record.category'){
							ret = 'read_sentence';
							this.errcode = 0;
						}
					}
                    return ret;
            }
        }
        catch (ex) {
            this.errcode = 301;
            return "";
        }

    },
    SetValue: function (parm1, parm2) {
		this.errcode = 0;
        if (this.comState == "Not Initialized") {
            this.errcode = 132;
            return "false";
        }
        if (this.comState == "Terminated") {
            this.errcode = 133;
            return "false";
        }
        if (!this.networkstate) {
            this.errcode = 6011;
            return "false";
        }
        if (IsReadOnly(parm1)) {
            this.errcode = 404;
            return "false";
        }

        try {
            if (parm1 == 'cci.service.goto') {
                var ret = GotoSco(parm2);
                this.errcode = 0;
                return 'true';
            }
			
			//SXKT-214 ϵͷ
            if (parm1 == 'cci.service.contact_us') {
                var ret = Contact_us(parm2);
                this.errcode = 0;
                return 'true';
            }

            if (parm1.indexOf('adl.data') != -1)
                this.adldatachanged = true;
            else if (parm1.indexOf('cci.service.new_words') != -1) {
                this.newwordchanged = true;
                if (parm1.indexOf('.sco_information') == -1) {
                    SetJsonVal(parm1.substr(0, parm1.lastIndexOf('.') + 1) + 'sco_information', this.scoid, this.data, this);
                }
            }
            //NPWEB-278
            else if (parm1.indexOf('cci.data') != -1) {
                this.ccidatachanged = true;
                if (parm1.indexOf('.sco_information') == -1) {
                    SetJsonVal(parm1.substr(0, parm1.lastIndexOf('.') + 1) + 'sco_information', this.scoid, this.data, this);
                }
            }
            //NPWEB-278 end

            var ret = SetJsonVal(parm1, parm2, this.data, this).toString();
            if (ret=='true')
                this.errcode = 0;
            return ret;
        }
        catch (ex) {
            this.errcode = 351;
            return "false";
        }
    },
    Commit: function (parm) {

        if (this.comState == "Not Initialized") {
            this.errcode = 142;
            return "false";
        }
        if (this.comState == "Terminated") {
            this.errcode = 143;
            return "false";
        }
        if (parm != "") {
            this.errcode = 201;
            return "false";
        }

        try {
            SetStudyInfo(this);
            this.errcode = 0;
            return "true";
        }
        catch (ex) {
            if (ex == "timeout")
                this.errcode = 6011;
            else
                this.errcode = 391;
            return "false";
        }
    },
    GetLastError: function () {
        return this.errcode.toString();
    },
    GetErrorString: function (parm) {
        switch (parm) {
            case 102:
                return "General Initialization Failure";
                break;
            case 103:
                return "Already Initialized";
                break;
            case 104:
                return "Content Instance Terminated";
                break;
            case 111:
                return "General Termination Failure";
                break;
            case 112:
                return "Termination Before Initialization";
                break;
            case 113:
                return "Termination After Termination";
                break;
            case 122:
                return "Retrieve Data Before Initialization";
                break;
            case 123:
                return "Retrieve Data After Termination";
                break;
            case 132:
                return "Store Data Before Initialization";
                break;
            case 133:
                return "Store Data After Termination";
                break;
            case 142:
                return "Commit Before Initialization";
                break;
            case 143:
                return "Commit After Termination";
                break;
            case 201:
                return "General Argument Error";
                break;
            case 301:
                return "General Get Failure";
                break;
            case 351:
                return "General Set Failure";
                break;
            case 391:
                return "General Commit Failure";
                break;
            case 401:
                return "Undefined Data Model Element";
                break;
            case 404:
                return "Data Model Element Is Read Only";
                break;
            case 6001:
                return "Dictionary Headword Not Set";
                break;
            case 6002:
                return "Delete Request Number Exceed Count";
                break;
            case 6003:
                return "Request Current UserID Failed";
                break;
            case 6004:
                return "Request Current UserAccount Failed";
                break;
            case 6005:
                return "Request Current UserName / UserToken Failed";
                break;
            case 6006:
                return "Request Current ClassID Failed";
                break;
            case 6007:
                return "Request Current ClassName Failed";
                break;
            case 6008:
                return "Request Class Response Count Failed";
                break;
            case 6009:
                return "Request Class Average Score Failed";
                break;
            case 6010:
                return "Request Class Average Time Failed";
                break;
            case 6011:
                return "Network Failed";
                break;
            //            case 6012:   
            //                return "Request Test ID Not Exist";   
            //                break;   
            case 6013:
                return "Essay Marking Not Submited";
                break;
            case 6014:
                return "Essay Marking Not Finished";
                break;
            case 6015:
                return "Set Request Number Exceed Count";
                break;
            case 6016:
                return "Recording Not Init";
                break;
            case 6017:
                return "Recording File Not Exist";
                break;
            case 6018:
                return "Recording Script Not Submited";
                break;
            case 6019:
                return "Oral Scoring Not Finished";
                break;
            default:
                return "";
                break;
        }
        return "";
    },
    GetDiagnostic: function (parm) {
        return "";
    }
};

function GetJsonVal(str, data, lms) {
    tempData = data;
    var obj;
    var parts = str.split('.');

    var tmpstr = '';
    for (var i = 0; i < parts.length; i++) {
        if (isNaN(parts[i]))
            tmpstr += '.' + parts[i];
        else
            tmpstr += '[' + parts[i] + ']';
    }
    if (tmpstr.length > 0)
        str = tmpstr.substring(1);

    try {

        //ǵһֺ͵ϢһԼصǰscoн
        if (parts[3] == "learner_comments" && !lms.hasGetLearnerComment) {
            lms.hasGetLearnerComment = true;
            try {
                GetLearnerComments(API_1484_11);
            }
            catch (err) {
                if (err == "timeout") {
                    lms.errcode = 6011;
                    return "";
                }
            }
        }
        //ǵһʦֺ͵ϢһԼصǰscoн
        else if (parts.length == 5 && parts[3] == 'teacher_comment' && !lms.hasGetTeaComment) {
            try {
                GetTeacherComment(API_1484_11);
            }
            catch (err) {
                if (err == "timeout") {
                    lms.errcode = 6011;
                    return "";
                }
            }
            lms.hasGetTeaComment = true;
        }
        //ǵһݣһԼصǰscoн
        else if (parts[3] == 'sharers' && str.indexOf('cmi.interactions[') == 0 && !lms.hasGetShareInfo) {
            try {
                GetShareInfo(API_1484_11);
            }
            catch (err) {
                if (err == "timeout") {
                    lms.errcode = 6011;
                    return "";
                }
            }
            lms.hasGetShareInfo = true;
        }

        //ָָߵϢڷǰȻȡۼۻظ
        if (parts[3] == 'sharers' && parts[5] == 'learner_comments' /*&& !lms.hasGetShareComment*/) {
            var hasgetsc = false;
            for (var i = 0; i < lms.hasGetShareCommentArray.length; i++) {
                if (lms.hasGetShareCommentArray[i] == parts[2] + ',' + parts[4]) {
                    hasgetsc = true;
                    break;
                }
            }
            //            lms.hasGetShareComment = true;
            if (!hasgetsc) {
                lms.hasGetShareCommentArray.push(parts[2] + ',' + parts[4]);
                try {
                    GetShareComment(API_1484_11, parts[2], parts[4]);
                }
                catch (err) {
                    if (err == "timeout") {
                        lms.errcode = 6011;
                        return "";
                    }
                }
            }
        }

        if (parts.length <= 3 && parts[parts.length - 1] != "_children" && parts[parts.length - 1] != "_count") {

            if (str == 'cci.response_status.response_count') {   //Ѵͳ

                if (GetJsonVal("cmi.mode", data, lms) == "browse") {   //browseģʽ¿ɲ鿴

					if (lms.classResponseCount != undefined) {
						lms.errcode = 0;
						return lms.classResponseCount;
					}

					var ret = GetClassResponseCount(API_1484_11);
					if (ret == 6008 || ret == 6011) {
						lms.errcode = ret;
						return '';
					}
					else {
						lms.errcode = 0;
						return ret;
					}
				}
				else
					return '';
            }
            else if (str == 'cci.response_status.average_score') {   //Ѵͳ

                if (GetJsonVal("cmi.mode", data, lms) == "browse") {   //browseģʽ¿ɲ鿴

					if (lms.classAvgScore != undefined) {
						lms.errcode = 0;
						return lms.classAvgScore;
					}

					var ret = GetClassAvgScore(API_1484_11);
					if (ret == 6009 || ret == 6011) {
						lms.errcode = ret;
						return '';
					}
					else {
						lms.errcode = 0;
						return ret;
					}
				}
				else
					return '';
            }
            else if (str == 'cci.response_status.average_time') {   //Ѵͳ

                if (GetJsonVal("cmi.mode", data, lms) == "browse") {   //browseģʽ¿ɲ鿴

					if (lms.classAvgTime != undefined) {
						lms.errcode = 0;
						return lms.classAvgTime;
					}

					var ret = GetClassAvgTime(API_1484_11);
					if (ret == 6010 || ret == 6011) {
						lms.errcode = ret;
						return '';
					}
					else {
						lms.errcode = 0;
						return ret;
					}
				}
				else
					return '';
            }
            else
                obj = eval("data." + str);
        }
        else {
            if (str.indexOf('cci.service.record.files') == 0)
                CheckCCIAppend('cci.service.record.files', data);
            else if (str.indexOf('cci.service.play.offline_media_id') == 0)
                CheckCCIAppend('cci.service.play.offline_media_id', data);

            if (parts[parts.length - 1] == "_children" || parts[parts.length - 1] == "_count") {
                str = str.substring(0, str.lastIndexOf('.'));
                obj = eval("tempData." + str);

                if (parts[parts.length - 1] == "_children") {
                    obj = JsonToString(obj);
                }
                else {
                    obj = GetJsonKeyCount(obj);
                }
            }
            else {
                if (str == 'cci.service.dictionary.short_cuts') {
                    var word = GetJsonVal("cci.service.dictionary.headword", data, lms);
                    if (word == "") {
                        lms.errcode = 6001;
                        return "";
                    }
                    else {
                        var ret = GetWord(word);
                        if (ret == 6001 || ret == 6011) {
                            lms.errcode = ret;
                            return "";
                        }
                        else {
                            lms.errcode = 0;
                            return ret;
                        }
                    }
                }
                else if (str == 'cci.service.dictionary.more') {
                    var word = GetJsonVal("cci.service.dictionary.headword", data, lms);
                    if (word == "") {
                        lms.errcode = 6001;
                        return "";
                    }
                    else {
                        var ret = GetWordMore(word);
                        if (ret == 6001) {
                            lms.errcode = 6001;
                            return "";
                        }
                        else {
                            lms.errcode = 0;
                            return ret;
                        }
                    }
                }
                else if (str == 'cci.service.user.id') {
                    if (lms.curUserID != '' && lms.curUserID != undefined) {
                        lms.errcode = 0;
                        return lms.curUserID;
                    }

                    var ret = GetCurrentUserID(API_1484_11);
                    if (ret == 6003) {
                        lms.errcode = 6003;
                        return "";
                    }
                    else {
                        lms.errcode = 0;
                        return ret;
                    }
                }
                else if (str == 'cci.service.user.account') {
                    if (lms.curUserAccount != '' && lms.curUserAccount != undefined) {
                        lms.errcode = 0;
                        return lms.curUserAccount;
                    }

                    var ret = GetCurrentUserAccount(API_1484_11);
                    if (ret == 6004) {
                        lms.errcode = 6004;
                        return "";
                    }
                    else {
                        lms.errcode = 0;
                        return ret;
                    }
                }
                else if (str == 'cci.service.user.name') {
                    if (lms.curUserName != '' && lms.curUserName != undefined) {
                        lms.errcode = 0;
                        return lms.curUserName;
                    }

                    var ret = GetCurrentUserName(API_1484_11);
                    if (ret == 6005) {
                        lms.errcode = 6005;
                        return "";
                    }
                    else {
                        lms.errcode = 0;
                        return ret;
                    }
                }
                else if (str == 'cci.service.user.token') {
                    if (lms.curUserToken != '' && lms.curUserToken != undefined) {
                        lms.errcode = 0;
                        return lms.curUserToken;
                    }

                    var ret = GetCurrentUserToken(API_1484_11);
                    if (ret == 6005) {
                        lms.errcode = 6005;
                        return "";
                    }
                    else {
                        lms.errcode = 0;
                        return ret;
                    }
                }
                else if (str == 'cci.service.class.id') {
                    if (lms.curClassID != undefined) {
                        lms.errcode = 0;
                        return lms.curClassID;
                    }

                    var ret = GetClassID(API_1484_11);
                    if (ret == 6006) {
                        lms.errcode = 6006;
                        return "";
                    }
                    else {
                        lms.errcode = 0;
                        return ret;
                    }
                }
                else if (str == 'cci.service.class.name') {
                    if (lms.curClassName != undefined) {
                        lms.errcode = 0;
                        return lms.curClassName;
                    }

                    var ret = GetClassName(API_1484_11);
                    if (ret == 6007 || ret == 6011) {
                        lms.errcode = ret;
                        return "";
                    }
                    else {
                        lms.errcode = 0;
                        return ret;
                    }
                }
				 else if (str == 'cci.service.network.reachability_status') {
                    lms.errcode = 0;
                    return GetNetworkStatus();
                }
                else if (str == 'cci.service.record.rtmserver') {
                    lms.errcode = 0;
                    return GetRecordRtmServer();
                }
                else if (str == 'cci.service.record.posturl') {
                    lms.errcode = 0;
                    return GetRecordPostUrl();
                }
                else if (str == 'cci.service.record.playurl') {
                    lms.errcode = 0;
                    return GetRecordPlayUrl();
                }
                else if (str == 'cci.service.play.baseurl') {
                    lms.errcode = 0;
                    return GetMediaUrl(API_1484_11);
                }
                else if (str == 'cci.service.record.uploadurl') {
                    lms.errcode = 0;
                    return GetRecordUploadUrl();
                }

               else if (str.indexOf('cci.service.record.files[') == 0 && parts[parts.length - 1] == "filename") { //cci.service.record.files.n.filename
                    var recordFileCount = GetJsonVal("cci.service.record.files._count", data, lms);
                    var curIndex = parseInt(parts[parts.length - 2]);
                    if (recordFileCount == "" || curIndex >= parseInt(recordFileCount)) { //δ֪ļԶ
                        var recordFileName = GetJsonVal("cci.service.user.id", data, lms) + '_' + GetCourseID(API_1484_11) + '_' + lms.scoid + '_' + curIndex;
                        //                        CheckCCIAppend('cci.service.record.files', data);
                        SetJsonVal('cci.service.record.files.' + curIndex + '.filename', recordFileName, data, lms);

                        lms.errcode = 0;
                        return recordFileName;
                    }
				}
		        else if (str.indexOf('cci.service.record.files[') == 0 && parts[parts.length - 1] == "playurl") { //cci.service.record.files.n.playurl
//                    var recordFileCount = GetJsonVal("cci.service.record.files._count", data, lms);
                    var curIndex = parseInt(parts[parts.length - 2]);
					//
					var recordFileName = GetJsonVal("cci.service.user.id", data, lms) + '_' + GetCourseID(API_1484_11) + '_' + lms.scoid + '_' + curIndex;
					  lms.errcode = 0;
					return GetRecordPlayUrl(recordFileName);
                }
                else if (str == "cci.service.record.result") {
                    var obj = getRecordScore();
                    if (obj.score == -1) {
                        lms.errcode = 6017;
                        return "";
                    } else if (obj.score == -2) {
                        lms.errcode = 6018;
                        return "";
                    } else if (obj.score == -3) {
                        lms.errcode = 6019;
                        return "";
                    } else {
						lms.errcode = 0;
                        return obj.score+"";
                    }
                }
				 else if (str == "cci.service.record.result_detail") {
                    var obj = getRecordScore();
					/* if (obj.score == -1) {
                        lms.errcode = 6017;
                        return "";
                    } else if (obj.score == -2) {
                        lms.errcode = 6018;
                        return "";
                    } else if (obj.score == -3) {
                        lms.errcode = 6019;
                        return "";
					} else 
					*/	
					if(obj.detail== undefined){
						lms.errcode = 6019;
                        return "";
					}else {
						lms.errcode=0;
						return obj.detail;
					}
                   
                }
                else if (parts.length == 4 && parts[3] == 'response_status')  //cmi.interactions.n.response_status
                {
                    if (GetJsonVal("cmi.mode", data, lms) == "browse") {   //browseģʽ¿ɲ鿴

                        //Ϣͬcmi.interactions.n.statistic
                        str = "cmi.interactions." + parts[parts.length - 2] + ".statistic";
                        obj = GetJsonVal(str, data, lms);
                        if (obj != undefined && obj != '') {
                            lms.errcode = 0;
                            return obj;
                        }
                    }
                    return '';
                }
                else if (parts[2] == 'writing_marking' && parts[parts.length - 1] == 'result') {
                    var emp_eid = GetJsonVal("cci.service.writing_marking." + parts[parts.length - 2] + ".emp_eid", data, lms);
                    if (emp_eid != "") {
                        try {
                            var wmResult = GetEssayMarkingResult(emp_eid);
                            if (wmResult == 6014 || wmResult == 6013) {
                                lms.errcode = wmResult;
                                return "";
                            }
                            lms.errcode = 0;
                            return wmResult;
                        } catch (err) {
                            if (err == 'timeout') {
                                lms.errcode = 6011;
                                return "";
                            }
                        }
                    }
                    else {
                        //жǷύƽ̨ύķʧܣlearner_responseemp_eid
                        var learner_response = GetJsonVal("cci.service.writing_marking." + parts[parts.length - 2] + ".learner_response", data, lms);
                        if (learner_response != "") { //Զύ
                            try {
                                SubmitEssayMarking(API_1484_11, parts[parts.length - 2], learner_response);
                            } catch (err) {
                                if (err == "timeout") {
                                    lms.errcode = 6011;
                                    return "";
                                }
                            }
                        }
                        else
                            lms.errcode = 6013;
                        return "";
                    }
                }

                obj = eval("tempData." + str);
            }
        }
    }
    catch (e) {
        obj = undefined;
    }

    if (obj == undefined) {
        lms.errcode = 401;
        return "";
    }
    lms.errcode = 0;
    return obj;
}

function SetJsonVal(str, val, data, lms) {

    if (val != null) {
        val = val.toString().replace(/\\/g, "\\\\");
        val = val.toString().replaceAll("\'", "\\'").replaceAll("\n", "\\n");
    }

    tempData = data;
    var inputStr = str;

    //app¼ר
    if (str == "cci.service.record.init") {
        var strScript = GetJsonVal("cci.service.record.script", data, lms);
        var ret=InitRecord(val, strScript,API_1484_11);
		if (ret != "true") {	
			lms.errcode= 6016;	
		}
		return ret;
    }
    else if (str == 'cci.service.record.action') {
        if (val == "stop") {
			var ret= StopRecord();
			if (ret != "true") {
				lms.errcode= 6016;
			}
			return ret;
        }
        return "true";
    }
    //app¼ר end

    var parts = str.split('.');
    //.n.Ϊ[n]
    var tmpstr = '';
    for (var i = 0; i < parts.length; i++) {
        if (isNaN(parts[i]))
            tmpstr += '.' + parts[i];
        else
            tmpstr += '[' + parts[i] + ']';
    }
    if (tmpstr.length > 0)
        str = tmpstr.substring(1);

    if (str.indexOf('cci.') != -1 && str.indexOf('cci.service') == -1) {
        CheckCCIAppend(str, data);
    }
    var obj;

    try {
        if (isNaN(parseInt(parts[parts.length - 2]))) {
            //obj = eval("data."+str);
            if (val == "__delete")
                obj = (new Function("", "delete tempData." + str + ";return true;"))();
            else
                obj = (new Function("", "tempData." + str + "='" + val + "';return tempData." + str + ";"))();
        }
        else {
            if (parts.length <= 5 || str.indexOf('cci.service.record.files[') == 0) {
                var num = parseInt(parts[parts.length - 2]);

                var newstr = "";
                for (var i = 0; i < parts.length - 2; i++)
                    newstr += "." + parts[i];

                //				newstr = newstr.substr(1) + "[" + num + "]." + parts[parts.length-1];
                newstr = newstr.substr(1);

                //жǷ 
                try {
                    obj = (new Function("", "if(tempData." + newstr + " == null){tempData." + newstr + "=[];} return tempData." + newstr + ";"))();
                } catch (e) {
                    obj = undefined;
                }
                if (obj == undefined) {
                    lms.errcode = 401;
                    return false;
                }

                var objCount = parseInt(GetJsonVal(newstr + "._count", data, lms)); //alert(num + ">=" + objCount);
                if (num >= objCount) {
                    if (val != "__delete") {
                        if (num > objCount) {
                            obj = undefined;
                            lms.errcode = 6015;
                            return false;
                        }
                        obj = (new Function("", "tempData." + newstr + ".push({'" + parts[parts.length - 1] + "':'" + val + "'});return tempData." + str + ";"))();
                    }
                    else {
                        obj = undefined;
                        lms.errcode = 6002;
                        return false;
                    }
                }
                else {
                    if (val == "__delete") {
                        //alert("data." + newstr + ".splice(" + num + ",1); return true;");
                        obj = (new Function("", "tempData." + newstr + ".splice(" + num + ",1); return true;"))();
                    }
                    else {
                        obj = (new Function("",
                            "tempData." + str + "='" + val + "'; return tempData." + str + ";"
                            ))();
                    }
                }

                //ύĵ
                if (val != "__delete" && parts[2] == 'writing_marking' && parts[parts.length - 1] == 'learner_response') {
                    try {
                        SubmitEssayMarking(API_1484_11, num, val);
                    } catch (err) {
                        if (err == "timeout") {
                            lms.errcode = 6011;
                            return "";
                        }
                    }
                }
            }
            else {
                var n = parseInt(parts[2]);

                newstr = '';
                var createstr = '';
                for (var i = 0; i < parts.length - 2; i++) {
                    if (isNaN(parts[i])) {
                        newstr += '.' + parts[i];
                        if (i == parts.length - 3)
                            createstr += "['" + parts[i] + "']";
                        else
                            createstr += '.' + parts[i];
                    }
                    else {
                        newstr += '[' + parts[i] + ']';
                        createstr += '[' + parts[i] + ']';
                    }
                }
                if (newstr.length > 0) {
                    newstr = newstr.substring(1);
                    createstr = createstr.substring(1);
                }

                //жǷ 
                try {
                    obj = (new Function("", "if(tempData." + newstr + " == null){tempData." + createstr + "=[];} return tempData." + newstr + ";"))();
                } catch (e) {
                    obj = undefined;
                }
                if (obj == undefined) {
                    lms.errcode = 401;
                    return false;
                }

                var objCount = parseInt(GetJsonVal(newstr + "._count", data, lms));
                if (!isNaN(parts[parts.length - 2]))
                    n = parseInt(parts[parts.length - 2]);
                if (n >= objCount) {
                    if (val != "__delete") {
                        if (n > objCount) {
                            obj = undefined;
                            lms.errcode = 6015;
                            return false;
                        }
                        if (val == null)
                            obj = (new Function("", "tempData." + newstr + ".push({'" + parts[parts.length - 1] + "':[]});return tempData." + str + ";"))();
                        else
                            obj = (new Function("", "tempData." + newstr + ".push({'" + parts[parts.length - 1] + "':'" + val + "'});return tempData." + str + ";"))();
                    }
                    else {
                        obj = undefined;
                        lms.errcode = 6002;
                        return false;
                    }
                }
                //		        else {
                if (val == "__delete") {

                    //ɾۻۻظͬݿ
                    if (inputStr.indexOf('.learner_comments.') != -1) {
                        try {
                            DeleteInteractionCommentOrReply(API_1484_11, inputStr);
                        }
                        catch (err) {
                            if (err == "timeout") {
                                lms.errcode = 6011;
                                return "";
                            }
                        }
                    }

                    obj = (new Function("", "tempData." + newstr + ".splice(" + n + ",1); return true;"))();
                }
                else {
                    if (val == null)
                        obj = (new Function("",
                            "tempData." + str + "=[]; return tempData." + str + ";"
                            ))();
                    else
                        obj = (new Function("",
                            "tempData." + str + "='" + val + "'; return tempData." + str + ";"
                            ))();

                    if (parts[parts.length - 1] == "reply" && parts[parts.length - 3] == "replies") {
                        try {
                            InsertInteractionReply(API_1484_11, parts);
                        }
                        catch (err) {
                            if (err == "timeout") {
                                lms.errcode = 6011;
                                return "";
                            }
                        }
                    }
                    else if (parts[3] == "sharers" && parts[parts.length - 3] == "learner_comments" && parts[parts.length - 1] != "isid") {
                        var isid = GetJsonVal(newstr + "." + parts[parts.length - 2] + ".isid", data, lms);
                        if (isid == '') {
                            var result = GetJsonVal(newstr + "." + parts[parts.length - 2] + ".result", data, lms);
                            var comment = GetJsonVal(newstr + "." + parts[parts.length - 2] + ".comment", data, lms);
                            if (result != '' && comment != '') {
                                //		                            var id = GetJsonVal("cci.service.user.id", data, lms);
                                //		                            var name = GetJsonVal("cci.service.user.name", data, lms);		                            
                                try {
                                    InsertShareComment(API_1484_11, parts, result, comment);
                                }
                                catch (err) {
                                    if (err == "timeout") {
                                        lms.errcode = 6011;
                                        return "";
                                    }
                                }
                            }
                        }
                    }
                }
                //		        }
            }

            //obj = eval("data."+str);
        }
    }
    catch (e) {
        obj = undefined;
    }

    if (obj == undefined && obj != null) {
        lms.errcode = 401;
        return false;
    }

    //obj = val;
    data = tempData;
    return true;
}

function CheckCCIAppend(str, data) {
    tempData = data;
    var obj = undefined;
    try {
        var obj = eval("tempData." + str);
    } catch (ex) { }
    if (obj != undefined)
        return;

    var idx = str.lastIndexOf('.');
    var parentStr = str.substring(0, idx);
    try {
        obj = eval("tempData." + parentStr);
    } catch (ex) { obj = undefined; }

    if (obj != undefined)
        return;
    else {
        CheckCCIAppend(parentStr, data);
        obj = (new Function("", "tempData." + parentStr + "={};return tempData." + parentStr + ";"))();
    }

    data = tempData;
}

function GetJsonKeyCount(obj) {
    var c = 0;
    for (var key in obj) {
        c++;
    }
    return c;
}

//var readonlywords = "._children,._count,.launch_data,.session_time,.total_time,.short_cuts,.sco_information,.course_ information,cci.mode,.statistic";
/*var readonlywords = "._children,._count,.response_status,.teacher_comment,.user,.class";
function IsReadOnly(str) {
    var words = readonlywords.split(',');
    for (var w in words) {
        if (str.indexOf(words[w]) != -1) {
            return true;
        }
    }

    return false;
}*/

//API_1484_11 = new LMS();
var defaultData = '{"cmi":{"completion_status":"not_attempted","interactions":[],"launch_data":"","progress_measure":"0","score":{"scaled":"","raw":""},"session_time":"0","success_status":"unknown","total_time":"0","mode":"normal"},"adl":{"data":[]},"cci":{"data":[],"service":{"dictionary":{"headword":"","short_cuts":""},"new_words":[],"notes":[],"writing_marking":[],"record":{"files":[],"language":"en_us","category":"read_sentence"},"play":{"offline_media_id":"9999"}},"retry_count":"0"}}';
/*
var defaultData = '{    \
    "cmi": {    \
        "completion_status": "not_attempted",   \
        "interactions": [], \
        "launch_data": "",  \
        "progress_measure": "0",    \
        "score": { "scaled": "", "raw": "" },   \
        "session_time": "0",    \
        "success_status": "unknown",    \
        "total_time": "0",  \
        "mode": "normal"    \
    },  \
    "adl": {    \
        "data": []  \
    },  \
    "cci": {    \
        "data": [], \
        "service": {    \
            "dictionary": { "headword": "", "short_cuts": "" }, \
            "new_words": [],    \
            "notes": [],    \
            "writing_marking": [],  \
            "record": { \
                "files": [] \
            },   \
            ,"play":{"offline_media_id":"9999"} \
        },  \
        "retry_count": "0"  \
    }   \
}';*/

function JsonToString(o) {
    var arr = [];
    var fmt = function (s) {
        if (typeof s == 'object' && s != null) return JsonToString(s);
        return /^(string|number)$/.test(typeof s) ? "'" + s + "'" : s;
    }
    for (var i in o)
        arr.push("'" + i + "':" + fmt(o[i]));
    return arr.join(',');
}

/* ʵּҳ */
/*
//ȡѧϰϢ
function GetStudyInfo(scoid){
return studyinfo;
}

//ѧϰϢ
function SetStudyInfo(apiObj){
return true;
}

//ȡ
function GetWord(w){
return "";
}

//ȡǰsessionѧϰʱ
function GetSessionTime(apiObj)
{
return 0;
}

//ȡǰûID
function GetCurrentUserID(apiObj)
{
return '';
}   
//ȡǰû˺
function GetCurrentUserAccount(apiObj)
  
//ȡǰû
function GetCurrentUserName(apiObj)
{
return '';
}

//ȡǰûToken
function GetCurrentUserToken(apiObj)
{
return '';
}

//ȡ༶
function GetClassResponseCount(apiObj)
{}
//ȡ༶ƽȷ
function GetClassAvgScore(apiObj)
{}
//ȡ༶ƽʱ
function GetClassAvgTime(apiObj)
{}
//ƽ̨תָSCO
function GotoSco(sconame)
{}
//ȡǰ༶ID
function GetClassID(apiObj)
{
return '';
}
//ȡǰ༶
function GetClassName(apiObj)
{
return '';
}
//ȡǰγID
function GetCourseID(apiObj)
{
return '';
}

//ط¼ϴò
function GetRecordRtmServer()
{ return '';}
function GetRecordPostUrl()
{ return '';}
function GetRecordPlayUrl()
{ return '';}
function GetRecordUploadUrl()
{ return '';}
//¼طŵַļ
function GetRecordFilePlayUrl(filename)
{ return '';}


//ȡʦֺ͵
function GetTeacherComment(apiObj)
{}
//ȡûֺ͵
function GetLearnerComments(apiObj)
{}
//ȡϢ
function GetShareInfo(apiObj)
{}
//ȡָָߵĴֺϢ
function GetShareComment(apiObj, interactionNum, sharerNum)
{}
//ɾָۻظ
function DeleteInteractionCommentOrReply(apiObj, str)
{}
//жϲۻظ
function InsertInteractionReply(apiObj, parts)
{}
//жϲӷ
function InsertShareComment(apiObj, parts, result, comment);         
{}
//ύĵģcci.service.writing_marking.num.emp_eid
function SubmitEssayMarking(apiObj, num, essay)
{}
//emp_eidȡĵĽ
function GetEssayMarkingResult(emp_eid)
{}
//app¼רãȡcci.service.play.baseurl 
function GetMediaUrl()
{}
//app¼רãȡ¼÷
function getRecordScore()
{}
//app¼רãʼ¼
function InitRecord()
{}
//app¼רãֹͣ¼
function StopRecord()
{}
*/
String.prototype.trim = function () {
    return this.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
}
String.prototype.replaceAll = function (s1, s2) {
    return this.replace(new RegExp(s1, "gm"), s2);
}